#include <iostream>
#include <string>
using namespace std;

string wzgorze = "Taumatawhakatangihangakoauauotamateapokaiwhenuakitanatahu";
int dlugosc_wzgorze = wzgorze.length(); // Ustawiamy to tutaj, ponieważ w tym programie długość stringu wzgorze będzie wywoływana wiele razy, więc nie będziemy za każdym razem sprawdzać, czy się nie zmieniła.

string fraza = "eturip";
// Poniższa funkcja działa następująco:
//
// wzgorze = abcdefgabcdefg
// szukane = abc
//
// Jeżeli potraktujemy string jak tablicę, to możemy
// dosyć łatwo porównywać każdy znak tej "tablicy",
// z każdym znakiem "tablicy" szukane.
//
// i = 0 j = 0
// abcdefgabcdefg
// a           ZGADZA SIĘ, J++
//
// i = 1 j = 1
// abcdefgabcdefg
//  b          ZGADZA SIĘ, J++
//
// i = 2 j = 2
// abcdefgabcdefg
//   c         ZGADZA SIĘ, J++
//
// JEŻELI DŁUGOŚĆ SZUKANE (ABC) == J, WYSTAPIEN++ (czyli znaleziono szukaną frazę)
// na tym nie kończy się zliczanie, musimy pójść dalej, dlatego musimy wyzerować
// j, żeby zacząć porównywać od pierwszego znaku:
//
// i = 3 j = 0
// abcdefgabcdefg
//    a
//
// i = 4 j = 0
// abcdefgabcdefg
//     a
//
// i = 5 j = 0
// abcdefgabcdefg
//      a
//
// i = 6 j = 0
// abcdefgabcdefg
//       a
//
// i = 7 j = 0
// abcdefgabcdefg
//        a    ZGADZA SIĘ, J++
//
// i = 8 j = 1
// abcdefgabcdefg
//         b   ZGADZA SIĘ, J++
//
// i = 9 j = 2
// abcdefgabcdefg
//          c  ZGADZA SIĘ, J++
// Mało tego, j == fraza.length(), więc trzeba zwiększyć ilość wystąpień (wystapien++).
// ...

int zlicz(string szukane){
	int j = 0;
	int wystapien = 0;

	for(int i = 0; i < dlugosc_wzgorze; i++){
		if(wzgorze[i] == szukane[j]){
			j++;			// kolejność jest WAŻNA!
			if(j == szukane.length()){
				wystapien++;
				j = 0;
			}
		}
	}
	return wystapien;
}
int main(){

	cout << "a) Dlugosc " << wzgorze << " to " << dlugosc_wzgorze << "." << endl;
	// Wytłumaczenie:
	// funkcja length() podaje długość wyrazu bez potrzeby liczenia każdego znaku z osobna.
	// Jest częścią biblioteki <string>.

	// b)
	// Zliczamy:
	cout << "b) Ilosc a: " << zlicz("a")
	<< ", e: " << zlicz("e")
	<< ", i: " << zlicz("i")
	<< ", o: " << zlicz("o")
	<< ", u: " << zlicz("u")
	<< ", y: " << zlicz("y") << "." << endl;

	// c)
	// Zliczamy (korzystamy z poprzedniej funkcji) ilość wystąpień "eturip". Jeżeli to zero, to nie występuje w nazwie tego wzgórza "eturip".
	if(zlicz(fraza) >= 1) cout << "c) " << fraza << " wystepuje w " << wzgorze << "." << endl;
	else cout << "c) " << fraza << " nie wystepuje w " << wzgorze << "." << endl;
}
